; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH	= 800
WINDOWHEIGHT	= 600
MAP_SIZE	= 1024;Size Of Our .RAW Height Map 
STEP_SIZE	= 16;Width And Height Of Each Quad 
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0		
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	szReadWrite:QWORD;number of bytes actually read or write
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_LBUTTONDOWN
	je	wmLBUTTONDOWN
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	HeapFree,hHeap,0,g_HeightMap
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmLBUTTONDOWN:;Did We Receive A Left Mouse Click?
	xor	bRender,1
	jmp	@2
wmKEYDOWN:mov	al,r8b;wParam
        cmp	al,VK_ESCAPE;user press 'Esc'?
        je	wmDESTROY
	cmp	al,VK_UP
	movd	xmm0,scaleValue
	movd	xmm1,const0_001
	jne	@0
vkUP:;Is the UP ARROW key Being Pressed?
	addss	xmm0,xmm1;Increase the scale value to zoom in
	jmp	@1
@0:	cmp	al,VK_DOWN
	jne	@f
vkDOWN:; Is the DOWN ARROW key Being Pressed?
	subss	xmm0,xmm1;Decrease the scale value to zoom out
@1:	movd	scaleValue,xmm0
	jmp	@2
@@:     movd	xmm0,Trot
        movd	xmm1,const0_3
	cmp	al,VK_RIGHT
	jne	@f		
	addss	xmm0,xmm1
	jmp	@3
@@:     cmp	al,VK_LEFT 
	jne	wmBYE
	subss	xmm0,xmm1
@3:     movd	Trot,xmm0
@2:     invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	GetProcessHeap
	mov	hHeap,rax
;-------------------------------------------------------
 	invoke	RtlAllocateHeap,eax,HEAP_ZERO_MEMORY,MAP_SIZE * MAP_SIZE
	mov	g_HeightMap,rax;g_HeightMap	
        mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,eax,g_HeightMap,MAP_SIZE * MAP_SIZE,,0
        invoke	CloseHandle,esi

	invoke	glShadeModel,GL_SMOOTH;smooth shading
	movd	xmm3,const1
	movss	xmm2,xmm3
	movd	xmm1,const0_7
	xorps	xmm0,xmm0
	invoke	glClearColor;    
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LEQUAL ;  
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd500
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;clear screen before drawing
        invoke	glLoadIdentity ; 
	
        invoke	glMatrixMode,GL_MODELVIEW
	invoke	glPushMatrix
;	 Position	      View		Up Vector
	movq	xmm3,constd186
	movq	xmm2,constd194
	movq	xmm1,constd60
	movq	xmm0,constd212
	invoke	gluLookAt,,,,,constd55,constd171,rbx,constd1,rbx; This Determines Where The Camera's Position And View Is
	movd	xmm2,scaleValue
	movss	xmm1,xmm2
	mulss	xmm1,HEIGHT_RATIO
	movss	xmm0,xmm2
	invoke	glScalef

        xorps	xmm3,xmm3
	movd	xmm2,const1
	xorps	xmm1,xmm1
	movd	xmm0,Trot
	invoke	glRotatef

	invoke	RenderHeightMap,g_HeightMap; Render The Height Map
	invoke	glPopMatrix
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
RenderHeightMap proc 
local	x:dword
local	y:dword
local	z:dword

	push	rsi
	push	rdi
	cmp	bRender,0
	jz	@f
	mov	ecx,GL_QUADS
	jmp	@0
@@:	mov	ecx,GL_LINES
@0:	invoke	glBegin
	xor	esi,esi
@1:	xor	edi,edi
@2:;Get The (X, Y, Z) Value For The Bottom Left Vertex
	invoke	Height,esi,edi
	mov	y,eax
; Set The Color Value Of The Current Vertex
	invoke	SetVertexColor,esi,edi
	invoke	glVertex3i,esi,y,edi; Send This Vertex To OpenGL To Be Rendered (Integer Points Are Faster)
; Get The (X, Y, Z) Value For The Top Left Vertex
	lea	edx,[rdi+STEP_SIZE]
	mov	z,edx			
	invoke	Height,esi
	mov	y,eax
; Set The Color Value Of The Current Vertex
	invoke	SetVertexColor,esi,z
	invoke	glVertex3i,esi,y,z; Send This Vertex To OpenGL To Be Rendered
; Get The (X, Y, Z) Value For The Top Right Vertex
	lea	ecx,[rsi+STEP_SIZE]
	mov	x,ecx
	lea	edx,[rdi+STEP_SIZE]
	mov	z,edx
	invoke	Height
	mov	y,eax
; Set The Color Value Of The Current Vertex
	invoke	SetVertexColor,x,z
	invoke	glVertex3i,x,y,z; Send This Vertex To OpenGL To Be Rendered
; Get The (X, Y, Z) Value For The Bottom Right Vertex
	lea	ecx,[rsi+STEP_SIZE]
	mov	x,ecx
	invoke	Height,,edi
	mov	y,eax
; Set The Color Value Of The Current Vertex
	invoke	SetVertexColor,x,edi
	invoke	glVertex3i,x,y,edi; Send This Vertex To OpenGL To Be Rendered
	add	edi,STEP_SIZE
	cmp	edi,MAP_SIZE-STEP_SIZE
	jb	@2
	add	esi,STEP_SIZE
	cmp	esi,MAP_SIZE-STEP_SIZE
	jb	@1
	pop	rdi
	pop	rsi
	invoke	glEnd
	movd	xmm3,const1
	movss	xmm2,xmm3
	movss	xmm1,xmm3
	movss	xmm0,xmm3	; red
	invoke	glColor4f
	leave
	retn
RenderHeightMap endp
SetVertexColor	proc	x:dword,y:dword;Sets The Color Value For A Particular Index, Depending On The Height Index

	invoke	Height;x,y
	or	eax,eax
	jz	@f;if(!g_HeightMap) return;Make Sure Our Height Data Is Valid
	cvtsi2ss xmm2,eax
	divss	xmm2,const128;fColor = Height(g_HeightMap, x, y )/128;
;Assign This Blue Shade To The Current Vertex
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;(0, 0, fColor
@@:	leave
	retn
SetVertexColor	endp
Height	proc ;X:dword,Y:dword;This Returns The Height From A Height Map Index
	mov	rax,g_HeightMap
	or	eax,eax
	jz	exit0
	and	edx,3FFh;edx = y = Y % MAP_SIZE Error Check Our y Value
	shl	edx,10;edx = y * MAP_SIZE
	and	ecx,3FFh;ecx = x = X % MAP_SIZE Error Check Our x Value
	add	ecx,edx
	movzx	eax,byte ptr [rax+rcx];return g_HeightMap[x + (y * MAP_SIZE)];Index Into Our Height Array And Return The Height
exit0:	retn
Height	endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #34: Beautiful Landscapes By Means Of Height Mapping",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "Terrain.raw",0
g_HeightMap 	dq ?;
bRender		db TRUE
HEIGHT_RATIO  	dd 1.5
scaleValue	dd 0.15
hHeap		dq ?
Trot		dd 0
;-----------------------------
;float
const0_001	dd 0.001
const0_3	dd 0.3
const0_7	dd 0.7
const1		dd 1.0
const128	dd 128.0
;double
constd0_1	dq 0.1
constd1		dq 1.0
constd45	dq 45.0
constd55	dq 55.0
constd60	dq 60.0
constd171	dq 171.0
constd186	dq 186.0
constd194	dq 194.0
constd212	dq 212.0
constd500	dq 500.0
end